close all;
% load('25-Mar-2014-11-58-23_gende_fall.mat');
load('25-Mar-2014-12-00-02_stende_sammensig.mat');
% load('25-Mar-2014-11-59-14_gende_fall_siden.mat');
% load('25-Mar-2014-12-02-35_ging_i_sirkel.mat'); % IKKE BRUKBAR
% load('25-Mar-2014-11-30-54_Stol_med_nedsig.mat')
% load('25-Mar-2014-11-28-56.mat')
load('human_template.mat');
load('static.mat');
tic
% for j = 1:size(M1,2)

% M2_t = M2_t + 40000;
% M3_t = M3_t + 80000;

WLS = 1;
RLS = 1;
KALM_R = 1;
KALM_SPD = 1;
staticCL = 0;

motion_sensed_a = 0;
motion_sensed_b = 0;
motion_sensed_c = 0;

tot_range = linspace(FO,FO+2*FramesStitched,512*3);
pathloss = (-0.2e1 * log10(0.2e1) + log10(0.1e1 / pi./ (tot_range.*tot_range.*tot_range.*tot_range))) / (log10(0.2e1) + log10(0.5e1)); % r^4
% pathloss = (-0.2e1 * log10(0.2e1) + log10(0.1e1 / pi./ (tot_range.*tot_range))) / (log10(0.2e1) + log10(0.5e1)); % r^2
path_amp = 1./(10.^(pathloss./10));

%% SE RDATA
RADAR_POSITION = [  2.2    3.4   1.43  ;
                     0.2    3.4   1.43  ;
                     0     0    0.7;]; %0.7

% for j = 2:404
%         
%         plot(M1_t(:,j),'r')
%         hold on
%         plot(M2_t(:,j),'g')
%         plot(M3_t(:,j),'b')                      
%         axis([0 1536 -25000 100000])
%         hold off
%         pause(0.1)
%     end
% 
%     %%
y1 = M1_t;
y2 = M2_t;
y3 = M3_t;

% y1(:,1) = 0;
% y2(:,1) = 0;
% y3(:,1) = 0;

    Mean1 = [M1_t(:,1:10)];
    Mean2 = [M2_t(:,1:10)];
    Mean3 = [M3_t(:,1:10)];
    
    CL1 = 0;
    CL2 = 0; %ORG
    CL3 = 0;
    
    CLM1 = staticCLM1;
    CLM2 = staticCLM2; % TEST
    CLM3 = staticCLM3;
    
    CL1norm = 0;
    CL2norm = 0;
    CL3norm = 0;
    
    r_a_prev = 0;
    r_b_prev = 0;
    r_c_prev = 0;
    
    r_a_new = 0;
    r_b_new = 0;
    r_c_new = 0;
    
    alpha   = 0.9;  % CLUTTER REMOVED FILTER
    lp_alpha = 0.75;
    beta    = 0.5;  % RANGE UPDATE FILERING
    kappa   = 1;    % CLNORM FILTER
    phi     = 0.99;    % Y filter
    
    for j = 2:10
        y1(:,j) = phi*y1(:,j-1) + (1-phi)*y1(:,j);
        y2(:,j) = phi*y2(:,j-1) + (1-phi)*y2(:,j);
        y3(:,j) = phi*y3(:,j-1) + (1-phi)*y3(:,j);
    end
    
%     R_sqrd  = FO+1/512:1/512:FO+FramesStitched;
%     R_sqrd  = 1:numCounters;
%     R_sqrd  = R_sqrd.*R_sqrd;
%     R_sqrd  = R_sqrd' + FO;
    
    
    %% Frequency Correlation variables
      ht_length   = length(human_template);
                window = 1:ht_length;
    
                for a = 1:ht_length
                    for b =1:ht_length
                        W(a,b) = exp(-sqrt(-1)*2*window(a)*window(b)*pi/ht_length);
                    end
                end
                W = W./sqrt(ht_length);
                w_rs = W*human_template';
                W_beta = diag([0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 1 1 1 1])*W;
                gamma = 0.7;
%%KALMAN VARIABLES I
% STATES ARE X = [x, y, z, x_d, y_d, z_d, x_dd, y_dd, z_dd ]'
A_c = [ 0  0  0  1  0  0  0  0  0;
        0  0  0  0  1  0  0  0  0;
        0  0  0  0  0  1  0  0  0;
        0  0  0  0  0  0  1  0  0;
        0  0  0  0  0  0  0  1  0;
        0  0  0  0  0  0  0  0  1;
        0  0  0  0  0  0  0  0  0;
        0  0  0  0  0  0  0  0  0;
        0  0  0  0  0  0  0  0  0;];
    
E_c = [ 0  0  0  0  0  0  1  0  0;
        0  0  0  0  0  0  0  1  0;
        0  0  0  0  0  0  0  0  1;]';
    
% dt = 1;
dt = 1/(i/time);
% time

[A_d,E] = c2d(A_c,E_c,dt);

% P_priori = eye(9)*50; 
P_posteori = eye(9)*100; % UNCERTAIN WHERE WE INITIALIZE
% P_pred = zeros(9);

% X_priori = [0,0,1.5,0,0,0,0,0,0]';
X_posteori = [0,0,1.5,0,0,0,0,0,0]'; % UNCERTAIN WHERE WE INITIALIZE

% PREDICTION = zeros(9,1);
PREDICTION = eye(9,1);
% PREDICTION = [7 5 1.5 1 1 1 1 1 1]';

H = [1,0,0,0,0,0,0,0,0; % OBSERVED STATES OR MEASURED VALUES
     0,1,0,0,0,0,0,0,0;
     0,0,1,0,0,0,0,0,0];

Sigma_Q = [1 0 0;0 1 0 ; 0 0 0.1]; % STOR Q, MYE ENDRING AV SYSTEMET
Sigma_R = [0.1 0 0; 0 0.1 0; 0 0 .01]; % LAV R STOR TILLIT TIL OBSERVERT MLING
%% %%KALMAN VARIABLES II

% STATES ARE X = [r1, r2, r3, r1_d, r2_d, r3_d, r1_dd, r2_dd, r3_dd ]'
% Ar_c = [ 0  0  0  1  0  0  0  0  0;
%         0  0  0  0  1  0  0  0  0;
%         0  0  0  0  0  1  0  0  0;
%         0  0  0  0  0  0  1  0  0;
%         0  0  0  0  0  0  0  1  0;
%         0  0  0  0  0  0  0  0  1;
%         0  0  0  0  0  0  0  0  0;
%         0  0  0  0  0  0  0  0  0;
%         0  0  0  0  0  0  0  0  0;];

Ar_c = [ 0  0  0  1  0  0 ;
         0  0  0  0  1  0 ;
         0  0  0  0  0  1 ;
         0  0  0  0  0  0 ;
         0  0  0  0  0  0 ;
         0  0  0  0  0  0 ;];


    
Er_c = [ 0  0  0  1  0  0;
         0  0  0  0  1  0;
         0  0  0  0  0  1;]';

    
% dt = 0.1;
dt = 1/(i/time);

[Ar_d,Er] = c2d(Ar_c,Er_c,dt);

% Er = 

Pr_pred = eye(6);
% P_pred = zeros(9);

ESTIMATE_RANGE = eye(6,1);

% PREDICTION = zeros(9,1);
PREDICTION_RANGE = eye(6,1);
% PREDICTION = [7 5 1.5 1 1 1 1 1 1]';

Hr = [1,0,0,0,0,0; % OBSERVED STATES OR MEASURED VALUES
      0,1,0,0,0,0;
      0,0,1,0,0,0];
estimate_RANGE_plot = [];

% 
% Sigma_Q_range = [0.50 0 0; 0 5 0; 0 0 50];
% Sigma_R_range = [10 0 0;0 0.1 0;0 0 0.01];


Sigma_Q_range = [100 0 0; 0 100 0; 0 0 100];
Sigma_R_range = [0.1 0 0;0 0.1 0;0 0 0.1];


% Ar_c = [0 1; 0 0];
% Er_c = [0; 1];
% 
% [Ar_d,Er] = c2d(Ar_c,Er_c,dt);
% 


M1_t_lp = M1_t;
% y1 = 0;
[dud, n_vals] = min(var(M1_t));
    for j = 10:n_vals-1
%% CLUTTERMAPPING AND FILTERING
M1_t_lp(:,j) = lp_alpha*M1_t_lp(:,j-1) + (1-lp_alpha)*M1_t(:,j);
        Mean1 = [Mean1(:,2:end) M1_t(:,j)];
        Mean2 = [Mean2(:,2:end) M2_t(:,j)];
        Mean3 = [Mean3(:,2:end) M3_t(:,j)];
        
%         Mean1 = [M1_t(:,j-1) M1_t(:,j)];
%         Mean2 = [M2_t(:,j-1) M2_t(:,j)];
%         Mean3 = [M3_t(:,j-1) M3_t(:,j)];
        
%         y = phi*M1_t(:,j) + (1-phi)*y;
        
%         CLM1 = M1_t(:,j-1)';
%         CLM2 = M2_t(:,j-1)';
%         CLM3 = M3_t(:,j-1)';
% % [U1, S1, V1] = svd(Mean1,0);
% % [U2, S2, V2] = svd(Mean2,0);
% % [U3, S3, V3] = svd(Mean3,0);
% %         CLM1 = U1(:,1)*S1(1,1)*V1(:,1)';
% %         CLM2 = U2(:,1)*S2(1,1)*V2(:,1)';
% %         CLM3 = U3(:,1)*S3(1,1)*V3(:,1)';

        

%         CLM1 = mean(Mean1');
%         CLM2 = mean(Mean2');
%         CLM3 = mean(Mean3');
        
        CL1_p = CL1;
        CL2_p = CL2;
        CL3_p = CL3;
        
%         CL1 = M1_t(:,j)-CLM1(:,end);
%         CL2 = M2_t(:,j)-CLM2(:,end);
%         CL3 = M3_t(:,j)-CLM3(:,end);

%         CL1 = M1_t(:,j)-CLM1';
%         CL2 = M2_t(:,j)-CLM2'; % ORGINAL
%         CL3 = M3_t(:,j)-CLM3';
        
%         CL1 = M1_t(:,j)-CLM1';
%         CL2 = M2_t(:,j)-CLM2'; % TEST
%         CL3 = M3_t(:,j)-CLM3';
        y1(:,j) = phi*y1(:,j-1) + (1-phi)*y1(:,j);
        y2(:,j) = phi*y2(:,j-1) + (1-phi)*y2(:,j);
        y3(:,j) = phi*y3(:,j-1) + (1-phi)*y3(:,j);
        
        if staticCL == 1
            y1cm = y1(:,j)-y1(:,9);
            y2cm = y2(:,j)-y2(:,9);
            y3cm = y3(:,j)-y3(:,9);
        else
            y1cm = y1(:,j)-y1(:,j-1);
            y2cm = y2(:,j)-y2(:,j-1);
            y3cm = y3(:,j)-y3(:,j-1);
        end
        
        
        
        for lp_i = 2:length(y1cm)
            y1cm(i) = 0.999*y1cm(i-1)+0.001*y1cm(i);
            y2cm(i) = 0.999*y2cm(i-1)+0.001*y2cm(i);
            y3cm(i) = 0.999*y3cm(i-1)+0.001*y3cm(i);
        end

        
        
%         CL1 = (1-alpha)*CL1 + (alpha).*CL1_p;
%         CL2 = (1-alpha)*CL2 + (alpha).*CL2_p;
%         CL3 = (1-alpha)*CL3 + (alpha).*CL3_p;
        
        CL1 = y1cm;
        CL2 = y2cm;
        CL3 = y3cm;

% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %         if r_a_prev <27
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %             CL1(1:2*27) = CL1(1:2*27).*R_sqrd(1:2*27);
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %         elseif r_a_prev > numCounters-50
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %             CL1(end-2*27:end) = CL1(end-2*27:end).*R_sqrd(end-2*27:end);
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %         else
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %             CL1(r_a_prev-26:r_a_prev+26) = CL1(r_a_prev-26:r_a_prev+26).*R_sqrd(r_a_prev-26:r_a_prev+26);
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %         end
        
%% AMPLITUDE NORMALIZATION

            R_sqrd = path_amp';

%             CL1norm = kappa*CL1.*R_sqrd+(1-kappa)*CL1norm;
%             CL2norm = kappa*CL2.*R_sqrd+(1-kappa)*CL2norm;
%             CL3norm = kappa*CL3.*R_sqrd+(1-kappa)*CL3norm;
            

            CL1norm = y1cm.*R_sqrd;
            CL2norm = y2cm.*R_sqrd;
            CL3norm = y3cm.*R_sqrd;

            
%% SPATIAL XCORROLATION        
%             a = xcorr(CL1,human_template);
%             a = a(1536:end);
%             a = abs(a);
% 
%             b = xcorr(CL2,human_template);
%             b = b(1536:end);
%             b = abs(b);
% 
%             c = xcorr(CL3,human_template);
%             c = c(1536:end);
%             c = abs(c);
%% SPATIAL XCORROLATION WITH NORMALIZED FOR RANGE SIGNAL
            a = xcorr(CL1norm,human_template);
            a = a(1536:end);
            a = abs(a);

            b = xcorr(CL2norm,human_template);
            b = b(1536:end);
            b = abs(b);

            c = xcorr(CL3norm,human_template);
            c = c(1536:end);
            c = abs(c);
            
%% Frequency Correlation

              
%                 
%                 pulse_xcorr    = 1:numCounters-ht_length;
%                 freq_xcorr     = 1:numCounters-ht_length;
% 
%                 for k = 1:numCounters-ht_length
%                     a_f(k) = abs(conj(CL1(k:k+ht_length-1)'*W_beta)*w_rs);
%                     b_f(k) = abs(conj(CL2(k:k+ht_length-1)'*W_beta)*w_rs);
%                     c_f(k) = abs(conj(CL3(k:k+ht_length-1)'*W_beta)*w_rs);
%                 end
%                 
% %                 a_f = a_f./max(a_f);
% %                 b_f = b_f./max(b_f);
% %                 c_f = c_f./max(c_f);
% %                 freq_xcorr_norm = freq_xcorr./max(freq_xcorr);
% % 
% % % Combining
% % 
%                 a = ( 1-gamma)*a(1:end-ht_length) + gamma*a_f';
%                 b = ( 1-gamma)*b(1:end-ht_length) + gamma*b_f';
%                 c = ( 1-gamma)*c(1:end-ht_length) + gamma*c_f';
% 
% %                 comb_xcorr_norm =( 1-gamma)*pulse_xcorr_norm + gamma*freq_xcorr_norm';
% %                 comb_xcorr =( 1-gamma)*pulse_xcorr + gamma*freq_xcorr';
    %             std(comb_xcorr)
%% RANGE UPDATE
            r_update_bool_a = 1;
            r_update_bool_b = 1;
            r_update_bool_c = 1;
%             while r_update_bool_a == 1 || r_update_bool_b == 1 || r_update_bool_c == 1
                [v_a, n_a] = max(abs(a));
                [v_b, n_b] = max(abs(b));
                [v_c, n_c] = max(abs(c));

                r_a_prev = r_a_new;
                r_b_prev = r_b_new;
                r_c_prev = r_c_new;
%% Complex
r_T = 100;%400
o_T = 10000;
                if v_a > r_T
                    motion_sensed_a = 1;
                    if r_a_prev == 0
                        r_a_new = n_a;
                        r_update_bool_a = 0;
                    elseif abs(n_a-r_a_prev) > o_T

                        a(n_a) = 0;
                    else
                        r_a_new = n_a;
                        r_update_bool_a = 0;                        
                    end
                else
                    r_update_bool_a = 0;
                end
                
                if v_b > r_T
                    motion_sensed_b = 1;
                    if r_b_prev == 0
                        r_b_new = n_b;
                        r_update_bool_b = 0;
                    elseif abs(n_b-r_b_prev) > o_T
                        b(n_b) = 0;
                    else
                        r_b_new = n_b;
                        r_update_bool_b = 0;                        
                    end
                else
                    r_update_bool_b = 0;
                end
                
                if v_c > r_T
                    motion_sensed_c = 1;
                    if r_c_prev == 0
                        r_c_new = n_c;
                        r_update_bool_c = 0;
                    elseif abs(n_c-r_c_prev) > o_T
                        c(n_c) = 0;
                    else
                        r_c_new = n_c;
                        r_update_bool_c = 0;                        
                    end
                else
                    r_update_bool_c = 0;
                end
                
                %% SIMPLE
%                 if v_a > 400
%                     r_a_new = n_a;
%                 end               
%                 if v_b > 400
%                     r_b_new = n_b;
%                 end
%                 if v_c > 400
%                     r_c_new = n_c;
%                 end
%             end % while end
%% FILTERING OF RANGE UPDATE                
                r_a_new = double(int64(beta*r_a_new +(1-beta)*r_a_prev));
                r_b_new = double(int64(beta*r_b_new +(1-beta)*r_b_prev));
                r_c_new = double(int64(beta*r_c_new +(1-beta)*r_c_prev));

                if r_a_new == 0;
                    range_plot_a  = zeros(1536,1);
                else
                    range_plot_a  = zeros(1536,1);
                    range_plot_a(r_a_new) = 1;
                end

                if r_b_new == 0;
                    range_plot_b  = zeros(1536,1);
                else
                    range_plot_b  = zeros(1536,1);
                    range_plot_b(r_b_new) = 1;
                end

                if r_c_new == 0;
                    range_plot_c  = zeros(1536,1);
                else
                    range_plot_c  = zeros(1536,1);
                    range_plot_c(r_c_new) = 1;
                end
                
%% KALMAN FILTERING RANGE
if KALM_R == 1;

            OBSERVATION_RANGE = [r_a_new,r_b_new,r_c_new,0,0,0]'; % CHANGE

            K_range = Pr_pred*Hr'*inv(Hr*Pr_pred*Hr'+Sigma_R_range);
            ESTIMATE_RANGE = PREDICTION_RANGE + K_range*(Hr*OBSERVATION_RANGE-Hr*PREDICTION_RANGE);
            Pr_hat   = (eye(6)-K_range*Hr)*Pr_pred*(eye(6)-K_range*Hr)' + K_range*Sigma_R_range*K_range';
            PREDICTION_RANGE  = Ar_d*ESTIMATE_RANGE;
            Pr_pred  = Ar_d*Pr_hat*Ar_d' + Er*Sigma_Q_range*Er';
%             Z_real_plot(:,j) = Z_real;
            estimate_RANGE_plot(:,j) = ESTIMATE_RANGE;
            if ESTIMATE_RANGE(1) > 1
                klm_a = abs(int64(ESTIMATE_RANGE(1)));
            else
                klm_a = 1;
            end
            
            if ESTIMATE_RANGE(2) > 1
                klm_b = int64(ESTIMATE_RANGE(2));
            else
                klm_b = 1;
            end
            
            if ESTIMATE_RANGE(3) > 1
                klm_c = int64(ESTIMATE_RANGE(3));
            else
                klm_c = 1;
            end
            
            if klm_a > 1536
                klm_a = 1536;
            end
            if klm_b > 1536
                klm_b = 1536;
            end
            if klm_c > 1536
                klm_c = 1536;
            end
            
            range_plot_a_klm  = zeros(1536,1);
            range_plot_a_klm(klm_a) = 1;
            
            range_plot_b_klm  = zeros(1536,1);
            range_plot_b_klm(klm_b) = 1;
            
            range_plot_c_klm  = zeros(1536,1);
            range_plot_c_klm(klm_c) = 1;

end        
if motion_sensed_a == 1 && motion_sensed_b == 1 && motion_sensed_c == 1
    %% WLS METODE  
    if WLS == 1
    % if r_update_bool_a ~= 1 && r_update_bool_b ~= 1 && r_update_bool_c ~= 1
%                         R = [r_a_new; r_b_new; r_c_new]; % SANS KALMAN
                        R = [ESTIMATE_RANGE(1); ESTIMATE_RANGE(2); ESTIMATE_RANGE(3)]; % KALMAN
                        R = R.*0.004+FO;

                        K = zeros(length(RADAR_POSITION(:,1)),1);
                        h = zeros(length(RADAR_POSITION(:,1))-1,1);
                        G = zeros(length(RADAR_POSITION(:,1))-1,length(RADAR_POSITION(1,:)));

                        for i = 1:length(RADAR_POSITION(:,1))
                            K(i) = R(i)^2 - RADAR_POSITION(i,1)^2 - RADAR_POSITION(i,2)^2 - RADAR_POSITION(i,3)^2;
                        end

                        for i = 1:length(h)
                            h(i) = 0.5*(K(i+1)-K(1));
                        end

                        for i = 1:size(G,1)
                            G(i,:) = [RADAR_POSITION(1,1)-RADAR_POSITION(i+1,1),RADAR_POSITION(1,2)-RADAR_POSITION(i+1,2),RADAR_POSITION(1,3)-RADAR_POSITION(i+1,3)];
                        end

                        Z_hat = G\h;
                        Z_hat_pl(:,j) = Z_hat;
                        
                        Z_hat_d_pl  = Z_hat_pl(1,2:end)  - Z_hat_pl(1,1:end-1);
                        Z_hat_dd_pl = Z_hat_d_pl(1,2:end)- Z_hat_d_pl(1,1:end-1);
    end
    %                     end
    % Z_hat = [0;0;0;];

    % %% GPS METODE
    if RLS == 1;
                i = 0;
    % %             step = 0.1;
                x_pre = [inf;inf;inf;];
                x_est2 = [Z_hat(1);Z_hat(2);Z_hat(3)];
                while(abs(x_pre(1)-x_est2(1))> 0.01 && abs(x_pre(2)- x_est2(2))> 0.01 && abs(x_pre(3)- x_est2(3))> 0.01 && i < 5)% && x_pre(2)~=x_est2(2) && x_pre(3)~=x_est2(3))
                    r1 = sqrt((RADAR_POSITION(1,1)-x_est2(1))^2+(RADAR_POSITION(1,2)-x_est2(2))^2+(RADAR_POSITION(1,3)-x_est2(3))^2);
                    r2 = sqrt((RADAR_POSITION(2,1)-x_est2(1))^2+(RADAR_POSITION(2,2)-x_est2(2))^2+(RADAR_POSITION(2,3)-x_est2(3))^2);
                    r3 = sqrt((RADAR_POSITION(3,1)-x_est2(1))^2+(RADAR_POSITION(3,2)-x_est2(2))^2+(RADAR_POSITION(3,3)-x_est2(3))^2);
    % %                 
                    r_1_obs = r_a_new.*0.004+FO;
                    r_2_obs = r_b_new.*0.004+FO;
                    r_3_obs = r_c_new.*0.004+FO;
    % % 
                    L_curr = -1*[(RADAR_POSITION(1,1)-x_est2(1))/r1,(RADAR_POSITION(1,2)-x_est2(2))/r1,(RADAR_POSITION(1,3)-x_est2(3))/r1;%,-1;
                                 (RADAR_POSITION(2,1)-x_est2(1))/r2,(RADAR_POSITION(2,2)-x_est2(2))/r2,(RADAR_POSITION(2,3)-x_est2(3))/r2;%,-1;
                                 (RADAR_POSITION(3,1)-x_est2(1))/r3,(RADAR_POSITION(3,2)-x_est2(2))/r3,(RADAR_POSITION(3,3)-x_est2(3))/r3];%,-1];
    % % 
                    del_ro = -1*[r1-r_a_new;r2-r_2_obs;r3-r_3_obs;];%-1];
                    x_pre = x_est2;
    % % 
                    x_est2 = x_est2 + inv(L_curr'*L_curr)*L_curr'*del_ro;
    % %                 if x_est2(3) < 0
    % %                     x_est2(3) = 0;
    % %                 elseif x_est2(3) > 3
    % %                     x_est2(3) = 3;
    % %                 end
                    i = i+1;
                end
    % %             x_pre = [1;1;1];
    %             Z_hat = x_est2
    end
    %% KALMAN
    if KALM_SPD == 1;
    %PREDICTION
                X_priori  = A_d*X_posteori;
                P_priori  = A_d*P_posteori*A_d' + E*Sigma_Q*E';
    %UPDATE
                OBSERVATION = [Z_hat(1),Z_hat(2),Z_hat(3),0,0,0,0,0,0]';          % CHANGE
%                 OBSERVATION = [x_est2(1),x_est2(2),x_est2(3),0,0,0,0,0,0]';          % CHANGE
%     Sigma_R = L_curr*Sigma_R_range*L_curr';%
    
    
                K = P_priori*H'*inv(H*P_priori*H'+Sigma_R);
                X_posteori = X_priori + K*(H*OBSERVATION-H*X_priori);
                P_posteori   = (eye(9)-K*H)*P_priori*(eye(9)-K*H)' + K*Sigma_R*K';
                %             Z_real_plot(:,j) = Z_real;
                estimate_plot(:,j) = X_posteori;    
    end
    %%
end

radar1 = [  2 0 1.43];
radar2 = [  0 0 1.43];
radar3 = [-0.2 -3.4 0.7];


% r_1 = 4.716990566;
x_01 = RADAR_POSITION(1,1);
y_01 = RADAR_POSITION(1,2);
z_01 = RADAR_POSITION(1,3);
% r_2 = 7.632168761;
x_02 = RADAR_POSITION(2,1);
y_02 = RADAR_POSITION(2,2);
z_02 = RADAR_POSITION(2,3);
% r_3 = 6.264982043;
x_03 = RADAR_POSITION(3,1);
y_03 = RADAR_POSITION(3,2);
z_03 = RADAR_POSITION(3,3);

r_1 = r_a_new*0.004 + FO;
r_2 = r_b_new*0.004 + FO;
r_3 = r_c_new*0.004 + FO;


ifshow = 1;
data = 0;
circles = 1;
kalman_c = 1;

kr_1 = ESTIMATE_RANGE(1)*0.004+FO;
kr_2 = ESTIMATE_RANGE(2)*0.004+FO;
kr_3 = ESTIMATE_RANGE(3)*0.004+FO;

range_diff(:,j) = [r_a_new*0.004+FO,kr_1];

if j==207
end

    if ifshow == 1;
        if data == 1;            
% % %         % %% Plot Clutter free signal

%                         plot(FO+1/256:1/256:FO+2*FramesStitched,CL1/100,'Color',[0 0 0],'LineWidth',2)
%                         hold on
%                         plot(FO+1/256:1/256:FO+2*FramesStitched,CL2/100+4,'Color',[0 0 0],'LineWidth',2)
%                         plot(FO+1/256:1/256:FO+2*FramesStitched,CL3/100+8,'Color',[0 0 0],'LineWidth',2)
        %                 axis([FO FO+2*FramesStitched -2000 10000])
        %             legend('Radar 1','Radar 2','Radar 3')
        %             hold off
        %             pause(0.01)
        %% Plot Clutter free signal normalized for range
                        plot(FO+1/256:1/256:FO+2*FramesStitched,CL1norm/1000,'Color',[0 0 0],'LineWidth',2)
                        axis([0 FO+2*FramesStitched -20 100])
                        hold off
                        hold on
                        plot(FO+1/256:1/256:FO+2*FramesStitched,CL2norm/1000+4,'Color',[0 0 0],'LineWidth',2)
                        plot(FO+1/256:1/256:FO+2*FramesStitched,CL3norm/1000+8,'Color',[0 0 0],'LineWidth',2)
        % %                 axis([FO FO+2*FramesStitched -2000 10000])
        % %             legend('Radar 1','Radar 2','Radar 3')
        % %             hold off
        % %             pause(0.01)

        %% Plot XCORR
                        plot(FO+1/256:1/256:FO+2*FramesStitched,a/1000,'Color',[1 0 0],'LineWidth',2)
%                         hold on
                        plot(FO+1/256:1/256:FO+2*FramesStitched,b/1000+4,'Color',[0 1 0],'LineWidth',2)
                        plot(FO+1/256:1/256:FO+2*FramesStitched,c/1000+8,'Color',[0 0 1],'LineWidth',2)
        %                 axis([FO FO+2*FramesStitched -2000 10000])
        %             legend('Radar 1','Radar 2','Radar 3')
        %             hold off
        %             pause(0.01)

        %% Plot KALMAN Range
                        plot(FO+1/256:1/256:FO+2*FramesStitched,range_plot_a_klm,'Color',[0.5 0.5 0],'LineWidth',2)
        %                 hold on
                        plot(FO+1/256:1/256:FO+2*FramesStitched,range_plot_b_klm+4,'Color',[0 0.5 0.5],'LineWidth',2)
                        plot(FO+1/256:1/256:FO+2*FramesStitched,range_plot_c_klm+8,'Color',[0.5 0 0.5],'LineWidth',2)
%                         axis([0 FO+2*FramesStitched -2 10])
        %% Plot Range
                        plot(FO+1/256:1/256:FO+2*FramesStitched,range_plot_a,'Color',[1 1 0],'LineWidth',2)
        %                 hold on
                        plot(FO+1/256:1/256:FO+2*FramesStitched,range_plot_b+4,'Color',[0 1 1],'LineWidth',2)
                        plot(FO+1/256:1/256:FO+2*FramesStitched,range_plot_c+8,'Color',[1 0 1],'LineWidth',2)
                        axis([0 FO+2*FramesStitched -2 10])
        %             legend('Radar 1','Radar 2','Radar 3')
                    hold off
        %             pause(0.05)

        elseif circles == 1
        %% PLOT RANGE CIRCLES
        %% Plot 2D/3D Localization Map     
        ang=0:0.01:2*pi; 

        
        
        %% ORGINAL!
        plot(x_01+r_1*cos(ang),y_01+r_1*sin(ang),'r');
        hold on
        plot(x_02+r_2*cos(ang),y_02+r_2*sin(ang),'g');
        plot(x_03+r_3*cos(ang),y_03+r_3*sin(ang),'b');
        
        %% PLOT RADAR LOCATION
        plot3(RADAR_POSITION(1,1),RADAR_POSITION(1,2),RADAR_POSITION(1,3),'LineWidth',3,'Marker','x','Color',[1 0 0])
        
        plot3(RADAR_POSITION(2,1),RADAR_POSITION(2,2),RADAR_POSITION(2,3),'LineWidth',3,'Marker','x','Color',[0 1 0])
        plot3(RADAR_POSITION(3,1),RADAR_POSITION(3,2),RADAR_POSITION(3,3),'LineWidth',3,'Marker','x','Color',[0 0 1])
%         plot3(RADAR_POSITION(3,1)+linspace(0,10),RADAR_POSITION(3,2)+linspace(0,10).*sind(100),RADAR_POSITION(3,3)+linspace(0,10).*0)
%         plot3(RADAR_POSITION(3,1)+linspace(0,10),RADAR_POSITION(3,2)-linspace(0,10).*sind(0),RADAR_POSITION(3,3)+linspace(0,10).*0)

        

        % hold off
        if kalman_c == 1
        plot(x_01+kr_1*cos(ang),y_01+kr_1*sin(ang),'Color',[0.5 0.5 0]);
        hold on
        plot(x_02+kr_2*cos(ang),y_02+kr_2*sin(ang),'Color',[0 0.5 0.5]);
        plot(x_03+kr_3*cos(ang),y_03+kr_3*sin(ang),'Color',[0.5 0 0.5]);
        end
        axis([-1 10 -10 0])

        % Plot 2D/3D Localization Map    
        if motion_sensed_a == 1 && motion_sensed_b == 1 && motion_sensed_c == 1
                        plot3(Z_hat(1),Z_hat(2),Z_hat(3),'LineWidth',3,'Marker','o','Color',[1 0 0]); % SANS KALMAN
%                         plot3(x_est2(1),x_est2(2),0,'LineWidth',3,'Marker','o','Color',[0 0 0]);
                        plot3(X_posteori(1),X_posteori(2),X_posteori(3),'LineWidth',3,'Marker','o','Color',[0 0 1]); % KALMAN
                        axis([-0.1 4 -5 5])
                        hold off
        end

        end

    % pause(dt)
    % % plot(y)
    % % pause(0.01)
    shg
    pause(0.05)
    end
    end
%% Plot 2D/3D Localization Map   

figure
plot(linspace(10,time,j),estimate_plot(1,:),'r')
hold on
plot(linspace(10,time,j),estimate_plot(4,:),'g')
plot(linspace(10,time,j),estimate_plot(7,:),'b')
title('X Kalman States')
legend('Position','Velocity','Acceleration')

figure
plot(linspace(10,time,j),estimate_plot(2,:),'r')
hold on
plot(linspace(10,time,j),estimate_plot(5,:),'g')
plot(linspace(10,time,j),estimate_plot(8,:),'b')
title('Y Kalman States')
legend('Position','Velocity','Acceleration')

figure
plot(linspace(10,time,j),estimate_plot(3,:),'r')
hold on
plot(linspace(10,time,j),estimate_plot(6,:),'g')
plot(linspace(10,time,j),estimate_plot(9,:),'b')
title('Z Kalman States')
legend('Position','Velocity','Acceleration')

figure
subplot(3,1,1)
plot(linspace(10,time,length(estimate_plot(3,:))),estimate_plot(3,:),'r')
title('Kalman Height Estimate ')
legend('Height')
ylabel('m')
xlabel('Time (s)')
subplot(3,1,2)
plot(linspace(10,time,length(estimate_plot(3,:))),estimate_plot(6,:),'g')
xlabel('Time (s)')
legend('Velocity')
ylabel('m/s')
subplot(3,1,3)
plot(linspace(10,time,length(estimate_plot(3,:))),estimate_plot(9,:),'b')
legend('acceleration')
xlabel('Time (s)')
ylabel('m/s^2')

clc
fprintf('DONE!\n')
toc
