clear
close all
clc
tic
a = -0.2;
b =  0.2;

RADAR_POSITION = [  0   0   2.5  ;
                   4   0   2.5  ;
                    2  4   2.5  ;
                   0  0  0 ;];
xp = 0;
yp = 2;
zp = 1.73;
rdr_nr = 3
body_error = 0;

Z_real = [xp; yp; zp;];

Z_plot = zeros(3,100);
ERROR_PLOT = zeros(100);
estimate_plot = zeros(9,100);
Z_real_plot = zeros(3,100);
Z_estimate_surf = zeros(100);

% KALMAN VARIABLER
% STATES ARE X = [x, y, z, x_d, y_d, z_d, x_dd, y_dd, z_dd ]'
A_c = [ 0  0  0  1  0  0  0  0  0;
        0  0  0  0  1  0  0  0  0;
        0  0  0  0  0  1  0  0  0;
        0  0  0  0  0  0  1  0  0;
        0  0  0  0  0  0  0  1  0;
        0  0  0  0  0  0  0  0  1;
        0  0  0  0  0  0  0  0  0;
        0  0  0  0  0  0  0  0  0;
        0  0  0  0  0  0  0  0  0;];
    
E_c = [ 0  0  0  0  0  0  1  0  0;
        0  0  0  0  0  0  0  1  0;
        0  0  0  0  0  0  0  0  1;]';
    
% dt = 0.1;
    
dt = 0.1;

[A_d,E] = c2d(A_c,E_c,dt);

P_pred = eye(9);
% P_pred = zeros(9);

ESTIMATE = zeros(9,1);

% PREDICTION = zeros(9,1);
PREDICTION = zeros(9,1);
% PREDICTION = [7 5 1.5 1 1 1 1 1 1]';

H = [1,0,0,0,0,0,0,0,0; % OBSERVED STATES OR MEASURED VALUES
     0,1,0,0,0,0,0,0,0;
     0,0,1,0,0,0,0,0,0];

Sigma_Q = [1 0 0; 0 1 0; 0 0 0.1]; % LAVERE Q GIR BEDRE STATIONARY RESPONS
% Sigma_R = [0.01 0 0; 0 0.01 0; 0 0 0.01];% LAV R STOR TILTRO TIL MLING
Sigma_R = 0.1;
Sigma_R = Sigma_R*eye(3);
% Sigma_R = 0;
%
xp_d = 2;
xp_dd = 0;

zp_d = 0;
zp_dd = -9.81;
Z= zeros(1,1000);
ZRMS   = zeros(1,1000);
Z_dRMS = zeros(1,1000);
Z_ddRMS = zeros(1,1000);
Z_hat_pl = zeros(3,1000);

detection_mean = zeros(1,50).*inf;
detection = zeros(1,1000);
detection_mat = zeros(10,1000);

detection_mean_klm = zeros(1,100).*inf;
detection_klm = zeros(1,1000);
detection_true = zeros(1,1000);
detection_true(600:end) = 1;
detection_mat_klm = zeros(10,1000);

 h_diff_detection = zeros(1,50);


T_detection = 0.45;

Z_Velcovity_integration = 0;
T_velocity_detection = -1;
T_h_diff_detection = 1.5;

detection_klm_velocity = zeros(1,1000);


NaNbool = 0;

for j = 1:1
    for jj = 1:1000
            if jj < 600
                xp = xp + 0.05*dt
    %             zp = zp + abs(0.1*cos(j));
                zp = 1.73 + abs(0.05*cos(jj*dt));

    %             Ztrue_d(j) = -0.05*sin(j*dt);
    %             Ztrue_dd(j) = -0.05*cos(j*dt);
            else
                if zp > 0.83
                    xp = xp + 0.1*dt;% xp_d*dt;
                    zp_d = zp_d + zp_dd*dt;
                    zp = zp + zp_d*dt;
                    Ztrue_d(jj) = zp_d;
%                     Ztrue_dd(jj) = zp_dd*dt;
                end
            end
            if zp < 0.83
                zp = 0.83;
                zp_d = 0;
    %             Ztrue_d(j) = 0;
            end
%             g = 0;
%             i = 0;
            Z(jj) = zp;
            Z_real = [xp;yp;zp;];
             R_obs = [];
                        for v = 1:rdr_nr;
                            R_obs(v)=sqrt((xp - RADAR_POSITION(v,1))^2 + (yp - RADAR_POSITION(v,2))^2 + (zp - RADAR_POSITION(v,3))^2)-(0.01)*randn;
                        end
                        R_obs = R_obs - 0.07;
%                         r1 = R_obs(1);
%                         r2 = R_obs(2);
%                         r3 = R_obs(3);

%                         R_obs = R_obs - 0.01;
    %                     R_obs = R_obs-0.01*abs(randn);
    %                     R_obs = R_obs-0.01*randn;
                        K = zeros(rdr_nr,1);
                        h = zeros(rdr_nr-1,1);
                        G = zeros(rdr_nr-1,length(RADAR_POSITION(1,:)));

    %                     for i = 1:length(RADAR_POSITION(:,1))
                        for i = 1:rdr_nr
                            K(i) = R_obs(i)^2 - RADAR_POSITION(i,1)^2 - RADAR_POSITION(i,2)^2 - RADAR_POSITION(i,3)^2;
                        end

                        for i = 1:length(h)
                            h(i) = 0.5*(K(i+1)-K(1));
                        end

                        for i = 1:size(G,1)
                            G(i,:) = [RADAR_POSITION(1,1)-RADAR_POSITION(i+1,1),RADAR_POSITION(1,2)-RADAR_POSITION(i+1,2),RADAR_POSITION(1,3)-RADAR_POSITION(i+1,3)];
                        end
%                         d = 10;
                        i = 0;
                        g = 0;
%                         j = 10;

                        Z_hat = G\h;
                        Z_hat_x(j,jj) = Z_hat(1);
                        Z_hat_y(j,jj) = Z_hat(2);
                        Z_hat_z(j,jj) = Z_hat(3);
%                         J = [R_obs(1)/RADAR_POSITION(2,1),-R_obs(2)/RADAR_POSITION(2,1),0;
%                              R_obs(1)/RADAR_POSITION(3,2)-(RADAR_POSITION(3,1)*R_obs(1))/(RADAR_POSITION(3,2)*RADAR_POSITION(1,2)),(RADAR_POSITION(1,3)*R_obs(2))/(RADAR_POSITION(3,2)*RADAR_POSITION(1,2)),-R_obs(3)/RADAR_POSITION(2,3);
%                              0,0,0]
%             J =  [R_obs(1) / RADAR_POSITION(2,1) -R_obs(2) / RADAR_POSITION(2,1) 0;
%                   R_obs(1) * (RADAR_POSITION(2,1) - RADAR_POSITION(1,3)) / RADAR_POSITION(3,2) / RADAR_POSITION(2,1) RADAR_POSITION(1,3) * R_obs(2) / RADAR_POSITION(3,2) / RADAR_POSITION(2,1) -R_obs(3) / RADAR_POSITION(3,2);
%                   (-(RADAR_POSITION(2,1) ^ 4 * RADAR_POSITION(1,3) ^ 2 + RADAR_POSITION(2,1) ^ 4 * RADAR_POSITION(3,2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) ^ 3 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 4 + 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * RADAR_POSITION(3,2) ^ 2 + 4 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 4 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(2,1) ^ 2 * R_obs(1) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * R_obs(3) ^ 4 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 4 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 * R_obs(2) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 * R_obs(3) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(2) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 * R_obs(2) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 4 + RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 * R_obs(2) ^ 2 + RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 4) / RADAR_POSITION(3,2) ^ 2 / RADAR_POSITION(2,1) ^ 2) ^ (-0.1e1 / 0.2e1) * R_obs(1) * (RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 - RADAR_POSITION(2,1) ^ 2 * R_obs(1) ^ 2 + RADAR_POSITION(2,1) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 + RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 - RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(2) ^ 2 - RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(3) ^ 2 - RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 2 - RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 + RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2) / RADAR_POSITION(3,2) ^ 2 / RADAR_POSITION(2,1) ^ 2 (-(RADAR_POSITION(2,1) ^ 4 * RADAR_POSITION(1,3) ^ 2 + RADAR_POSITION(2,1) ^ 4 * RADAR_POSITION(3,2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) ^ 3 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 4 + 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * RADAR_POSITION(3,2) ^ 2 + 4 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 4 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(2,1) ^ 2 * R_obs(1) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * R_obs(3) ^ 4 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 4 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 * R_obs(2) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 * R_obs(3) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(2) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 * R_obs(2) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 4 + RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 * R_obs(2) ^ 2 + RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 4) / RADAR_POSITION(3,2) ^ 2 / RADAR_POSITION(2,1) ^ 2) ^ (-0.1e1 / 0.2e1) * R_obs(2) * (RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 + RADAR_POSITION(3,2) ^ 2 * RADAR_POSITION(2,1) ^ 2 - RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 - RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 - RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 + RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(3) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 - RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 2 + RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 - RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2) / RADAR_POSITION(3,2) ^ 2 / RADAR_POSITION(2,1) ^ 2 -(RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) - RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 2 - RADAR_POSITION(2,1) * RADAR_POSITION(3,2) ^ 2 - RADAR_POSITION(2,1) * R_obs(1) ^ 2 + RADAR_POSITION(2,1) * R_obs(3) ^ 2 + RADAR_POSITION(1,3) * R_obs(1) ^ 2 - RADAR_POSITION(1,3) * R_obs(2) ^ 2) * R_obs(3) * (-(RADAR_POSITION(2,1) ^ 4 * RADAR_POSITION(1,3) ^ 2 + RADAR_POSITION(2,1) ^ 4 * RADAR_POSITION(3,2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) ^ 3 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) ^ 3 * RADAR_POSITION(1,3) * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 4 + 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * RADAR_POSITION(3,2) ^ 2 + 4 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 4 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) ^ 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(2,1) ^ 2 * R_obs(1) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(2,1) ^ 2 * R_obs(3) ^ 4 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) ^ 3 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 4 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 * R_obs(2) ^ 2 + 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(1) ^ 2 * R_obs(3) ^ 2 - 2 * RADAR_POSITION(2,1) * RADAR_POSITION(1,3) * R_obs(2) ^ 2 * R_obs(3) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(1,3) ^ 2 * R_obs(1) ^ 2 * R_obs(2) ^ 2 + RADAR_POSITION(1,3) ^ 2 * R_obs(2) ^ 4 + RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 4 - 2 * RADAR_POSITION(3,2) ^ 2 * R_obs(1) ^ 2 * R_obs(2) ^ 2 + RADAR_POSITION(3,2) ^ 2 * R_obs(2) ^ 4) / RADAR_POSITION(3,2) ^ 2 / RADAR_POSITION(2,1) ^ 2) ^ (-0.1e1 / 0.2e1) / RADAR_POSITION(3,2) ^ 2 / RADAR_POSITION(2,1);];
% J = [r1 / d -r2 / d 0; r1 * (d - i) / j / d i * r2 / j / d -r3 / j; (-(d ^ 4 * i ^ 2 + d ^ 4 * j ^ 2 - 2 * d ^ 3 * i ^ 3 - 2 * d ^ 3 * i * j ^ 2 - 2 * d ^ 3 * i * r1 ^ 2 + 2 * d ^ 3 * i * r3 ^ 2 + d ^ 2 * i ^ 4 + 2 * d ^ 2 * i ^ 2 * j ^ 2 + 4 * d ^ 2 * i ^ 2 * r1 ^ 2 - 2 * d ^ 2 * i ^ 2 * r2 ^ 2 - 2 * d ^ 2 * i ^ 2 * r3 ^ 2 + d ^ 2 * j ^ 4 - 2 * d ^ 2 * j ^ 2 * r2 ^ 2 - 2 * d ^ 2 * j ^ 2 * r3 ^ 2 + d ^ 2 * r1 ^ 4 - 2 * d ^ 2 * r1 ^ 2 * r3 ^ 2 + d ^ 2 * r3 ^ 4 - 2 * d * i ^ 3 * r1 ^ 2 + 2 * d * i ^ 3 * r2 ^ 2 - 2 * d * i * j ^ 2 * r1 ^ 2 + 2 * d * i * j ^ 2 * r2 ^ 2 - 2 * d * i * r1 ^ 4 + 2 * d * i * r1 ^ 2 * r2 ^ 2 + 2 * d * i * r1 ^ 2 * r3 ^ 2 - 2 * d * i * r2 ^ 2 * r3 ^ 2 + i ^ 2 * r1 ^ 4 - 2 * i ^ 2 * r1 ^ 2 * r2 ^ 2 + i ^ 2 * r2 ^ 4 + j ^ 2 * r1 ^ 4 - 2 * j ^ 2 * r1 ^ 2 * r2 ^ 2 + j ^ 2 * r2 ^ 4) / j ^ 2 / d ^ 2) ^ (-0.1e1 / 0.2e1) * r1 * (d ^ 3 * i - 2 * d ^ 2 * i ^ 2 - d ^ 2 * r1 ^ 2 + d ^ 2 * r3 ^ 2 + d * i ^ 3 + d * i * j ^ 2 + 2 * d * i * r1 ^ 2 - d * i * r2 ^ 2 - d * i * r3 ^ 2 - i ^ 2 * r1 ^ 2 + i ^ 2 * r2 ^ 2 - j ^ 2 * r1 ^ 2 + j ^ 2 * r2 ^ 2) / j ^ 2 / d ^ 2 (-(d ^ 4 * i ^ 2 + d ^ 4 * j ^ 2 - 2 * d ^ 3 * i ^ 3 - 2 * d ^ 3 * i * j ^ 2 - 2 * d ^ 3 * i * r1 ^ 2 + 2 * d ^ 3 * i * r3 ^ 2 + d ^ 2 * i ^ 4 + 2 * d ^ 2 * i ^ 2 * j ^ 2 + 4 * d ^ 2 * i ^ 2 * r1 ^ 2 - 2 * d ^ 2 * i ^ 2 * r2 ^ 2 - 2 * d ^ 2 * i ^ 2 * r3 ^ 2 + d ^ 2 * j ^ 4 - 2 * d ^ 2 * j ^ 2 * r2 ^ 2 - 2 * d ^ 2 * j ^ 2 * r3 ^ 2 + d ^ 2 * r1 ^ 4 - 2 * d ^ 2 * r1 ^ 2 * r3 ^ 2 + d ^ 2 * r3 ^ 4 - 2 * d * i ^ 3 * r1 ^ 2 + 2 * d * i ^ 3 * r2 ^ 2 - 2 * d * i * j ^ 2 * r1 ^ 2 + 2 * d * i * j ^ 2 * r2 ^ 2 - 2 * d * i * r1 ^ 4 + 2 * d * i * r1 ^ 2 * r2 ^ 2 + 2 * d * i * r1 ^ 2 * r3 ^ 2 - 2 * d * i * r2 ^ 2 * r3 ^ 2 + i ^ 2 * r1 ^ 4 - 2 * i ^ 2 * r1 ^ 2 * r2 ^ 2 + i ^ 2 * r2 ^ 4 + j ^ 2 * r1 ^ 4 - 2 * j ^ 2 * r1 ^ 2 * r2 ^ 2 + j ^ 2 * r2 ^ 4) / j ^ 2 / d ^ 2) ^ (-0.1e1 / 0.2e1) * r2 * (d ^ 2 * i ^ 2 + j ^ 2 * d ^ 2 - d * i ^ 3 - d * i * j ^ 2 - d * i * r1 ^ 2 + d * i * r3 ^ 2 + i ^ 2 * r1 ^ 2 - i ^ 2 * r2 ^ 2 + j ^ 2 * r1 ^ 2 - j ^ 2 * r2 ^ 2) / j ^ 2 / d ^ 2 -(d ^ 2 * i - d * i ^ 2 - d * j ^ 2 - d * r1 ^ 2 + d * r3 ^ 2 + i * r1 ^ 2 - i * r2 ^ 2) * r3 * (-(d ^ 4 * i ^ 2 + d ^ 4 * j ^ 2 - 2 * d ^ 3 * i ^ 3 - 2 * d ^ 3 * i * j ^ 2 - 2 * d ^ 3 * i * r1 ^ 2 + 2 * d ^ 3 * i * r3 ^ 2 + d ^ 2 * i ^ 4 + 2 * d ^ 2 * i ^ 2 * j ^ 2 + 4 * d ^ 2 * i ^ 2 * r1 ^ 2 - 2 * d ^ 2 * i ^ 2 * r2 ^ 2 - 2 * d ^ 2 * i ^ 2 * r3 ^ 2 + d ^ 2 * j ^ 4 - 2 * d ^ 2 * j ^ 2 * r2 ^ 2 - 2 * d ^ 2 * j ^ 2 * r3 ^ 2 + d ^ 2 * r1 ^ 4 - 2 * d ^ 2 * r1 ^ 2 * r3 ^ 2 + d ^ 2 * r3 ^ 4 - 2 * d * i ^ 3 * r1 ^ 2 + 2 * d * i ^ 3 * r2 ^ 2 - 2 * d * i * j ^ 2 * r1 ^ 2 + 2 * d * i * j ^ 2 * r2 ^ 2 - 2 * d * i * r1 ^ 4 + 2 * d * i * r1 ^ 2 * r2 ^ 2 + 2 * d * i * r1 ^ 2 * r3 ^ 2 - 2 * d * i * r2 ^ 2 * r3 ^ 2 + i ^ 2 * r1 ^ 4 - 2 * i ^ 2 * r1 ^ 2 * r2 ^ 2 + i ^ 2 * r2 ^ 4 + j ^ 2 * r1 ^ 4 - 2 * j ^ 2 * r1 ^ 2 * r2 ^ 2 + j ^ 2 * r2 ^ 4) / j ^ 2 / d ^ 2) ^ (-0.1e1 / 0.2e1) / j ^ 2 / d;0 0 0];


            if body_error == 1;
                    ESTIMATE_NLS = [Z_hat;0];
                    while ((i < 4) &&( g < 4))
%                         while (abs(PREVIOUS_ESTIMATE(1)-ESTIMATE(1)) > 0.001 || abs(PREVIOUS_ESTIMATE(2)-ESTIMATE(2)) > 0.001 || abs(PREVIOUS_ESTIMATE(3)-ESTIMATE(3)) > 0.001) && ((i < 10) &&( g < 10))

                        R_L = [];
                        for v = 1:rdr_nr;
                            R_L(v)=sqrt((RADAR_POSITION(v,1)-ESTIMATE_NLS(1))^2+(RADAR_POSITION(v,2)-ESTIMATE_NLS(2))^2+(RADAR_POSITION(v,3)-ESTIMATE_NLS(3))^2);
                        end


                        % Line Of Sight Matrix
                        L=[];
                        for v=1:rdr_nr
                            L = [L;(RADAR_POSITION(v,1)-ESTIMATE_NLS(1))/R_L(v),(RADAR_POSITION(v,2)-ESTIMATE_NLS(2))/R_L(v),(RADAR_POSITION(v,3)-ESTIMATE_NLS(3))/R_L(v),-1;];
                        end
                        L = -1*L;


                        del_ro = [];
                        for v = 1:rdr_nr
                            del_ro = [del_ro;R_L(v)-R_obs(v)];
                        end
                        del_ro = -1*del_ro;

                        PREVIOUS_ESTIMATE = ESTIMATE_NLS;

                        ESTIMATE_NLS = ESTIMATE_NLS + inv(L'*L)*L'*del_ro;
    %                     ESTIMATE_NLS = ESTIMATE_NLS + L_inv*del_ro;

                        xyz_est = ESTIMATE_NLS;
                        xyz_hat = Z_hat;
                        xyz_true = [xp;yp;zp];


                        if isnan(ESTIMATE_NLS(1))
                            NaNbool = 1;
                        end
                        if NaNbool == 0;
                            i = i+1;
                            x = j;
                            y= jj;
                            g = i;
                        else
                            g = g+1;
                        end
                    end
            else
                        ESTIMATE_NLS = Z_hat;
%                     while (abs(PREVIOUS_ESTIMATE(1)-ESTIMATE_NLS(1)) > 0.001 || abs(PREVIOUS_ESTIMATE(2)-ESTIMATE_NLS(2)) > 0.001 || abs(PREVIOUS_ESTIMATE(3)-ESTIMATE_NLS(3)) > 0.001) && ((i < 10) &&( g < 10))
                    while ((i < 4) &&( g < 4))



                        R_L = [];
                        for v = 1:rdr_nr;
                            R_L(v)=sqrt((RADAR_POSITION(v,1)-ESTIMATE_NLS(1))^2+(RADAR_POSITION(v,2)-ESTIMATE_NLS(2))^2+(RADAR_POSITION(v,3)-ESTIMATE_NLS(3))^2);
                        end

                        % Line Of Sight Matrix / Jacobian
                        L=[];
                        for v=1:rdr_nr
                            L = [L;(RADAR_POSITION(v,1)-ESTIMATE_NLS(1))/R_L(v),(RADAR_POSITION(v,2)-ESTIMATE_NLS(2))/R_L(v),(RADAR_POSITION(v,3)-ESTIMATE_NLS(3))/R_L(v);];
                        end
                        L = -1*L;

                        del_ro = [];
                        for v = 1:rdr_nr
                            del_ro = [del_ro;R_L(v)-R_obs(v)];
                        end
                        del_ro = -1*del_ro;

                        PREVIOUS_ESTIMATE = ESTIMATE_NLS;


    %                     [U,S,V] = svd(L);
    %                     S_star = [diag(1./diag(S'));0 0 0];
    %                     L_inv = V*S_star'*U';

    %                     ESTIMATE_NLS = ESTIMATE_NLS + L_inv*del_ro;
                        ESTIMATE_NLS = ESTIMATE_NLS + inv(L'*L)*L'*del_ro;    % ORGINAL

                        xyz_est = ESTIMATE_NLS;
                        xyz_hat = Z_hat;
                        xyz_true = [xp;yp;zp];

                        if isnan(ESTIMATE_NLS(1))
                            NaNbool = 1;
                        end
                        if NaNbool == 0;
                            i = i+1;
                            x = j;
                            y= jj;
                            g = i;
                        else
                            g = g+1;
                        end
                    end
            end
            X_HAT_ESTIMATE(j,jj) = Z_hat(1);
            Y_HAT_ESTIMATE(j,jj) = Z_hat(2);
            Z_HAT_ESTIMATE(j,jj) = Z_hat(3);

            X_ESTIMATE(j,jj) = ESTIMATE_NLS(1);
            Y_ESTIMATE(j,jj) = ESTIMATE_NLS(2);
            Z_ESTIMATE(j,jj) = ESTIMATE_NLS(3); 
            PREVIOUS_ESTIMATE = [inf;inf;inf];
%             J = -L;
%             QR = J'*Q*J;
%             A = 6*pi*sqrt(det(QR));
%             Mag_logA(j,jj,t)= log(A);
            % KALMAN
%             OBSERVATION = [Z_hat(1),Z_hat(2),Z_hat(3),0,0,0,0,0,0]';          % CHANGE
            OBSERVATION = [ESTIMATE_NLS(1),ESTIMATE_NLS(2),ESTIMATE_NLS(3),0,0,0,0,0,0]'; 

            K = P_pred*H'*inv(H*P_pred*H'+Sigma_R);
            ESTIMATE = PREDICTION + K*(H*OBSERVATION-H*PREDICTION);
            P_hat   = (eye(9)-K*H)*P_pred*(eye(9)-K*H)' + K*Sigma_R*K';
            PREDICTION  = A_d*ESTIMATE;
            P_pred  = A_d*P_hat*A_d' + E*Sigma_Q*E';
            Z_real_plot(:,jj) = Z_real;
            estimate_plot(:,jj) = ESTIMATE;    
            
            detection_mean_klm = [detection_mean_klm(2:end) ESTIMATE(3)];
            if jj > 100
                if  mean(detection_mean_klm) < T_detection
                    detection_klm(jj)= 1;
                end
            end
            if jj > 100
                h_diff_detection = [h_diff_detection(2:end) ESTIMATE(3)];
                
                if max(h_diff_detection )-min(h_diff_detection ) > T_h_diff_detection 
                    
%                     if abs(Z_Velcovity_integration) > T_velocity_detection;
                        detection_klm_velocity(jj) = 1;
%                     end

%                     Z_Velcovity_integration = 0;
                end                
            end
    end
    detection_mat_klm(j,:) = detection_klm;
    detection_mat(j,:) = detection;
%     T_detection = T_detection - 0.05
    
    detection_mean = zeros(1,50).*inf;
    detection = zeros(1,1000);

    detection_mean_klm = zeros(1,50).*inf;
    detection_klm = zeros(1,1000);
    
    Z_d = [0 Z(2:end)-Z(1:end-1)];
    Z_dd = [0 Z_d(2:end)-Z_d(1:end-1)];

    ZRMS = ZRMS+(Z-estimate_plot(3,:)).^2;
    Z_dRMS = Z_dRMS+(Z_d-estimate_plot(6,:)).^2;
    Z_ddRMS = Z_ddRMS+(Z_dd-estimate_plot(9,:)).^2;
    
    xp = 0;
    yp = 5;
    zp = 1.7;

    ESTIMATE = eye(9,1);
    PREDICTION = eye(9,1);
    
    
    
end
ZRMS = ZRMS/j;
Z_dRMS = Z_dRMS/j;
Z_ddRMS = Z_ddRMS/j;

ZRMS    = sqrt(ZRMS);
Z_dRMS  = sqrt(Z_dRMS);
Z_ddRMS = sqrt(Z_ddRMS);

% hold on
% plot3(estimate_plot(1,:),estimate_plot(2,:),estimate_plot(3,:),'LineWidth',1,'Color',[0 0 1]);
% plot3(Z_real_plot(1,:),Z_real_plot(2,:),Z_real_plot(3,:),'LineWidth',1,'Color',[1 0 0]);
% xlabel('x')
% ylabel('y')
% zlabel('z')
% title('Real and Kalman estimate of XYZ')
% axis([0 10 0 10 0 3])
% daspect([1 1 1]);
figure
subplot(2,1,1)
plot(linspace(0.1,100,1000),estimate_plot(3,:),'LineWidth',2,'Color',[0 0 1]);
hold on
% plot(Z_hat_pl(3,:),'LineWidth',1,'Color',[0 1 0]);
% plot(100:length(estimate_plot(1,:)),estimate_plot(3,100:end),'LineWidth',1,'Color',[0 0 1]);
plot(linspace(0.1,100,1000),Z,'LineWidth',2,'Color',[1 0 0]);

legend('z_h_a_t','z');
hold off
title('Kalman estimate of Z (Fall at 60)')
xlabel('time (s)')
ylabel('z , z_h_a_t (m)')
subplot(2,1,2)
plot(linspace(0.1,100,1000),detection_true,'LineWidth',2,'Color',[1 0 0])
hold on
plot(linspace(0.1,100,1000),detection_mat_klm(1,:),'LineWidth',2,'Color',[0 0 1])
title('Detection (Fall at 60)')
axis([0 100 -0.1 1.1])
ylabel('Detection Bool')
xlabel('time (s)')
legend('True fall','Detection')
hold off


% % % plot(Z,'LineWidth',2,'Color',[1 0 0]);
% % % hold off
% % % title('Kalman estimate of Z (Fall at 600)')
% % % % figure
% % % subplot(3,1,2)
% % % % plot(100:length(estimate_plot(1,:)),estimate_plot(6,100:end),'LineWidth',1,'Color',[0 0 1]);
% % % plot(1:length(estimate_plot(1,:)),estimate_plot(6,:),'LineWidth',2,'Color',[0 0 1]);
% % % hold on
% % % plot(Z_d,'LineWidth',2,'Color',[1 0 0]);
% % % hold off
% % % title('Kalman estimate of Z_d (Fall at 600)')
% % % % figure
% % % subplot(3,1,3)
% % % % plot(100:length(estimate_plot(1,:)),estimate_plot(9,100:end),'LineWidth',1,'Color',[0 0 1]);
% % % plot(1:length(estimate_plot(1,:)),estimate_plot(9,:),'LineWidth',2,'Color',[0 0 1]);
% % % hold on
% % % plot(Z_dd,'LineWidth',2,'Color',[1 0 0]);
% % % hold off
% % % title('Kalman estimate of Z_d_d (Fall at 600)')
% % % % plot(1:length(estimate_plot(1,:)),estimate_plot(1,:));
% % % % plot(1:length(estimate_plot(1,:)),estimate_plot(1,:));
% % % % plot(1:length(estimate_plot(1,:)),estimate_plot(1,:));
% % % % plot(1:length(estimate_plot(1,:)),estimate_plot(1,:));
figure
subplot(3,1,1)
plot(ZRMS);
subplot(3,1,2)
plot(Z_dRMS)
subplot(3,1,3)
plot(Z_ddRMS)
hold off
figure
surf(detection_mat_klm)
figure
surf(detection_mat)
toc






% surf(ERROR_PLOT)
% figure
% surf(ERROR_PLOT2)
% figure
% plot(1:100,Z_plot(1,:))
% figure
% plot(1:100,Z_plot(2,:))
% figure
% plot(1:100,error(:,1),1:100,error(:,2),1:100,error(:,3))
% figure
% plot(1:100,Z_plot(3,:))